.model compact

;device dependant functions used from ADLIB.C

ADPORT	equ	 388h

.data
_regspace label byte
          db    256 dup (1)
_regwork  label byte
          db    256 dup (2)
.code

global   _updateregspace:proc    ;send changed registers to AdLib card
global	_outadl:proc		      ;change state of register
global   _sbport:word

global   _regspace:byte
global   _regwork:byte


_outadl	proc
      push  bx
      mov   bx,ax
      xor   bh,bh
      mov   [_regwork+bx],ah
dontsetbyte:
      pop   bx
		ret
_outadl	endp

_updateregspace proc
      push  es
      push  si
      push  di
      push  bx
      push  ds
      pop   es
      mov   dx,ADPORT
      std
      lea   si,_regwork
      mov   cx,0f5h
      add   si,cx
      lea   di,_regspace
      add   di,cx
      inc   cx
nxe:
      repz  cmpsb
      jz    finished
      mov   al,cl
      out   dx,al
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		mov	al,ah
		inc	dx
      mov   al,[si+1]
      mov   [di+1],al
		out	dx,al
      dec   dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
		in		al,dx
      and   cx,cx
      jnz   nxe
finished:
      cld
      pop   bx
      pop   di
      pop   si
      pop   es
      ret
_updateregspace endp
end
