global regspace        :byte
global adl_outp        :proc

adl_outm macro
        local alrset

        push bx
        mov  bl,al
        xor  bh,bh
        cmp  [regspace+bx],ah
        jz   alrset
        mov  [regspace+bx],ah
        call adl_outp
alrset:
        pop  bx
endm

adl_out macro
        adl_outm
endm

IFDEF ENABLESFX
sfxheader struc
   sfxh_multi  db   2 dup (?)       ;frequency multiplication factor etc.
   sfxh_level  db   2 dup (?)       ;output level etc. parameters
   sfxh_ad     db   2 dup (?)       ;attack/decay parameter
   sfxh_sr     db   2 dup (?)       ;sustain/release parameter
   sfxh_wfm    db   2 dup (?)       ;waveform data
   sfxh_fbc    db   ?               ;feedback/connection byte
   sfxh_fqdata dw   ?               ;points to table of frequency data
   sfxh_lvdata dw   ?               ;points to table of output level data
   sfxh_len1   dw   ?               ;time of keyoff
   sfxh_len2   dw   ?               ;time of end of sound
sfxheader ends
ENDIF
