;INSTRUM.INC (C)1993 Johannes Bjerregaard. All rights reserved.
;--------------------------------------------------------------
;Defines the structure of a single tone, the element of which
;type one or two make up the sound responding to a single patch.

instrument struc
   reg20    db 2 dup (?)
   reg40    db 2 dup (?)
   reg60    db 2 dup (?)
   reg80    db 2 dup (?)
   regc0    db ?
   wave_form_for_modulator db ?
   wave_form_for_carrier   db ?
   velo_sens    db 2 dup (?)
   keyoff_reg60 db 2 dup (?)
   keyoff_reg80 db 2 dup (?)

   mod_lfo_depth db ?
   mod_lfo_rate  db ?
   detune        db ?
   coarse_detune db ?
   tvp_depth     db ?
   tvp_rate      db ?

   output_level  db 2 dup (?)
instrument ends

;operator number equivalents

MODULATOR     equ     0
CARRIER       equ     1

;values for combine method

FM            equ     1
ADDITIVE      equ     0

;end of file
