DATAVERSION        equ        0100h   ;data file version supported by driver
DEFAULT_IOPORT     equ        0388h   ;default value for AdLibIOAddr

;The following is a list of interface command numbers. See the description
;of procedure entry_point for further explanation.

MHC_RESET          equ        0       ;reset driver and hardware
MHC_LOADTUNE       equ        1       ;load patch info etc. from tune struct
MHC_NOTEON         equ        2       ;note on on channel 0-8
MHC_DRUMON         equ        3       ;note on on channel 9
MHC_NOTEOFF        equ        4       ;note off message
MHC_PITCHBEND_I    equ        5       ;recalc vce fq after chg in pitch bend
MHC_CHANGEIOADDR   equ        8       ;change I/O address
MHC_PITCHBENDSENS  equ        9       ;change sensitivity of pitch bender
MHC_PITCHBEND      equ        10      ;called externally to update pitch bend
MHC_MODULATION     equ        11      ;change value of modulation wheel
MHC_UPDATEREGSPACE equ        12      ;update hardware registers.
MHC_REALTIME       equ        13      ;update real time parameters

